/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package balonky;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.util.Random;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import javax.swing.BoxLayout;

/**
 *
 * @author petr
 */
public class Balonek implements Runnable {

    private static ExecutorService service = Executors.newCachedThreadPool();
    private static Random generator = new Random();
    private Dimension plocha;
    private Point pozice;
    private int polomer;
    private Color color;
    private Point speed;

    public Balonek(Dimension plocha) {
        this.plocha = plocha;
        polomer = 30 + generator.nextInt(50);
        pozice = new Point(generator.nextInt(plocha.width - polomer),
                generator.nextInt(plocha.height - polomer));
        color = new Color(generator.nextInt(256), generator.nextInt(256),
                generator.nextInt(256));
        speed = new Point(generator.nextInt(20), generator.nextInt(20));
        service.execute(this);
    }

    public void paint(Graphics g) {
        g.setColor(color);
        g.fillOval(pozice.x, pozice.y, polomer, polomer);
        g.setColor(Color.BLACK);
        g.drawOval(pozice.x, pozice.y, polomer, polomer);
    }

    public void run() {
        while (true) {
            pozice.x += speed.x;
            pozice.y += speed.y;
            if (pozice.x > plocha.width - polomer || pozice.x < 0) {
                speed.x *= -1;
            }
            if (pozice.y > plocha.height - polomer || pozice.y < 0) {
                speed.y *= -1;
            }
            try {
                Thread.sleep(75);
            } catch (InterruptedException ex) {
            }
        }
    }

    public Point getPozice() {
        return pozice;
    }

    public int getPolomer() {
        return polomer;
    }
}
